import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.WindowConstants;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class CRCReverserGUI extends javax.swing.JFrame {
	private JPanel Panel;
	private JMenuBar MenuBar;
	private JMenu menuFile;
	private JMenuItem itemFileGetHash;
	private JMenuItem itemFileSave;
	private JMenuItem itemFileExit;
	private JMenu menuLanguage;
	private JMenuItem itemLanguageItaliano;
	private JMenuItem itemLanguageEnglish;
	private JMenu menuHelp;
	private JMenuItem itemHelpAbout;
	private JDialog dialogAbout;
	private JTextArea textAreaDialogAbout;
	private JButton buttonDialogAboutOK;
	private JLabel Label1;
	private JTextField textHash;
	private JButton buttonStart;
	private JButton buttonEnd;
	private JLabel Label2;
	private JScrollPane ScrollPanel;
	private JTextArea textAreaResult;
	private JButton buttonClean;
	
	boolean stopSwingWorker = false;
	String textFileContent = "";
	BufferedReader inputStream;
	BufferedWriter outputStream;
	
	/**
	* Auto-generated main method to display this JFrame
	*/
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				CRCReverserGUI inst = new CRCReverserGUI();
				inst.setLocationRelativeTo(null);
				inst.setVisible(true);
			}
		});
	}
	
	public CRCReverserGUI() {
		super();
		initGUI();
	}
	
	private void initGUI() {
		try {
			setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
			this.setTitle("CRC Reverser 2.0");
			this.setResizable(false);
			getContentPane().add(getPanel(), BorderLayout.CENTER);
			{
				MenuBar = new JMenuBar();
				setJMenuBar(MenuBar);
				{
					menuFile = new JMenu();
					MenuBar.add(menuFile);
					menuFile.setText("File");
					{
						itemFileGetHash = new JMenuItem();
						menuFile.add(itemFileGetHash);
						itemFileGetHash.setText("Get hash from file");
						itemFileGetHash.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent evt) {
								itemFileGetHashActionPerformed(evt);
							}
						});
					}
					{
						itemFileSave = new JMenuItem();
						menuFile.add(itemFileSave);
						itemFileSave.setText("Save file with given hash");
						itemFileSave.setEnabled(false);
						itemFileSave.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent evt) {
								itemFileSaveActionPerformed(evt);
							}
						});
					}
					{
						itemFileExit = new JMenuItem();
						menuFile.add(itemFileExit);
						itemFileExit.setText("Exit");
						itemFileExit.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent evt) {
								itemFileExitActionPerformed(evt);
							}
						});
					}
				}
				{
					menuLanguage = new JMenu();
					MenuBar.add(menuLanguage);
					menuLanguage.setText("Language");
					{
						itemLanguageEnglish = new JMenuItem();
						menuLanguage.add(itemLanguageEnglish);
						itemLanguageEnglish.setText("English");
						itemLanguageEnglish.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent evt) {
								itemLanguageEnglishActionPerformed(evt);
							}
						});
					}
					{
						itemLanguageItaliano = new JMenuItem();
						menuLanguage.add(itemLanguageItaliano);
						itemLanguageItaliano.setText("Italian");
						itemLanguageItaliano.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent evt) {
								itemLanguageItalianoActionPerformed(evt);
							}
						});
					}
				}
				{
					menuHelp = new JMenu();
					MenuBar.add(menuHelp);
					menuHelp.setText("Help");
					{
						itemHelpAbout = new JMenuItem();
						menuHelp.add(itemHelpAbout);
						itemHelpAbout.setText("About");
						itemHelpAbout.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent evt) {
								itemHelpAboutActionPerformed(evt);
							}
						});
					}
				}
			}
			pack();
			setSize(400, 350);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}	
	
	private JDialog getDialogAbout() {
		if(dialogAbout == null) {
			dialogAbout = new JDialog(this);
			dialogAbout.setTitle("About");
			{
				buttonDialogAboutOK = new JButton();
				dialogAbout.getContentPane().add(buttonDialogAboutOK);
				buttonDialogAboutOK.setText("OK");
				buttonDialogAboutOK.setBounds(200, 120, 60, 20);
				buttonDialogAboutOK.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent evt) {
						buttonDialogAboutOKActionPerformed(evt);
					}
				});
			}
			{
				textAreaDialogAbout = new JTextArea();
				dialogAbout.getContentPane().add(textAreaDialogAbout);
				textAreaDialogAbout.setFocusable(false);
				textAreaDialogAbout.setEditable(false);
				textAreaDialogAbout.setBackground(dialogAbout.getBackground());
				textAreaDialogAbout.setLineWrap(true);
				textAreaDialogAbout.setWrapStyleWord(true);
				textAreaDialogAbout.setText("CRC Reverser v0.01\n (c) 2005 - Bas Westerbaan <bas.westerbaan@gmail.com>\n  Intrepid Software\n  Translated from Python to Java by Andrea Pannitti <andrea.pannitti@gmail.com>\n  GUI by Andrea Pannitti using Jigloo");
				textAreaDialogAbout.setBounds(0, 0, 60, 20);
				textAreaDialogAbout.setPreferredSize(new java.awt.Dimension(450, 180));
				textAreaDialogAbout.setDoubleBuffered(true);
			}
			dialogAbout.setSize(450, 180);
		}
		return dialogAbout;
	}
	
	private JPanel getPanel() {
		if(Panel == null) {
			Panel = new JPanel();
			Panel.setLayout(null);
			Panel.add(getLabel1());
			Panel.add(getTextHash());
			Panel.add(getButtonStart());
			Panel.add(getButtonEnd());
			Panel.add(getLabel2());
			Panel.add(getScrollPanel());
			Panel.add(getButtonClean());
		}
		return Panel;
	}
	
	private JLabel getLabel1() {
		if(Label1 == null) {
			Label1 = new JLabel();
			Label1.setText("CRC32 hash (decimal or h<exadecimal>):");
			Label1.setBounds(10, 5, 251, 15);
		}
		return Label1;
	}
	
	private JTextField getTextHash() {
		if(textHash == null) {
			textHash = new JTextField();
			textHash.setText("hF7D18982");
			textHash.setBounds(10, 20, 120, 20);
		}
		return textHash;
	}
	
	private JButton getButtonStart() {
		if(buttonStart == null) {
			buttonStart = new JButton();
			buttonStart.setText("Start");
			buttonStart.setBounds(12, 50, 80, 20);
			buttonStart.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					buttonStartActionPerformed(evt);
				}
			});
		}
		return buttonStart;
	}
	
	private JButton getButtonEnd() {
		if(buttonEnd == null) {
			buttonEnd = new JButton();
			buttonEnd.setText("End");
			buttonEnd.setBounds(100, 50, 80, 20);
			buttonEnd.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					buttonEndActionPerformed(evt);
				}
			});
		}
		return buttonEnd;
	}

	private JLabel getLabel2() {
		if(Label2 == null) {
			Label2 = new JLabel();
			Label2.setText("Result:");
			Label2.setBounds(12, 80, 80, 15);
		}
		return Label2;
	}

	private JScrollPane getScrollPanel() {
		if(ScrollPanel == null) {
			ScrollPanel = new JScrollPane();
			ScrollPanel.setBounds(12, 100, 368, 153);
			getContentPane().add(getTextAreaResult(), BorderLayout.CENTER);
			ScrollPanel.add(getTextAreaResult());
			{
				ScrollPanel.setViewportView(getTextAreaResult());
			}
		}
		return ScrollPanel;
	}

	private JTextArea getTextAreaResult() {
		if(textAreaResult == null) {
			textAreaResult = new JTextArea();
		}
		return textAreaResult;
	}
	
	private JButton getButtonClean() {
		if(buttonClean == null) {
			buttonClean = new JButton();
			buttonClean.setText("Clean");
			buttonClean.setBounds(12, 265, 80, 20);
			buttonClean.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					buttonCleanActionPerformed(evt);
				}
			});
		}
		return buttonClean;
	}
	
	private void itemFileGetHashActionPerformed(ActionEvent evt) {
		//System.out.println("itemFileExit.actionPerformed, event="+evt);
		JFileChooser fileChooser = new JFileChooser();
		int returnValue = fileChooser.showOpenDialog(this);
		
		if (returnValue==JFileChooser.APPROVE_OPTION) {
			try {
				int i;
				String s = "";
				Crc32Provider crc = new Crc32Provider();
				inputStream = new BufferedReader(new FileReader(fileChooser.getSelectedFile().getPath()));
				while((i = inputStream.read())!=-1) {
					s+=(char)i;
				}
				inputStream.close();
				crc.update(s);
				textHash.setText("h"+Long.toHexString(crc.getHash()).toUpperCase());
				textAreaResult.setText("");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	private void itemFileSaveActionPerformed(ActionEvent evt) {
		//System.out.println("itemFileExit.actionPerformed, event="+evt);
		JFileChooser fileChooser = new JFileChooser();
		int returnValue = fileChooser.showSaveDialog(this);
		
		if (returnValue==JFileChooser.APPROVE_OPTION) {
			try {
				outputStream = new BufferedWriter(new FileWriter(fileChooser.getSelectedFile().getPath(), true));
				outputStream.write(textFileContent);
				outputStream.close();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	private void itemFileExitActionPerformed(ActionEvent evt) {
		//System.out.println("itemFileExit.actionPerformed, event="+evt);
		System.exit(0);
	}

	private void itemLanguageEnglishActionPerformed(ActionEvent evt) {
		//System.out.println("itemLanguageEnglish.actionPerformed, event="+evt);
		ChangeLanguage(1);
	}

	private void itemLanguageItalianoActionPerformed(ActionEvent evt) {
		//System.out.println("itemLanguageItaliano.actionPerformed, event="+evt);
		ChangeLanguage(2);
	}

	private void itemHelpAboutActionPerformed(ActionEvent evt) {
		//System.out.println("itemHelpAbout.actionPerformed, event="+evt);
		getDialogAbout().pack();
		getDialogAbout().setLocationRelativeTo(null);
		getDialogAbout().setVisible(true);
	}

	private void buttonDialogAboutOKActionPerformed(ActionEvent evt) {
		//System.out.println("buttonDialogAboutOK.actionPerformed, event="+evt);
		getDialogAbout().dispose();
	}
	
	private void buttonStartActionPerformed(ActionEvent evt) {
		//System.out.println("buttonStart.actionPerformed, event="+evt);
		
		stopSwingWorker = false;
		
		final SwingWorker worker = new SwingWorker() {
			public Object construct() {
				Datamanipulation dm = new Datamanipulation();
				long hash = 4157704578L;
		
				if(textHash.getText().length() > 0){
					if(textHash.getText().toLowerCase().charAt(0)=='h'){
						hash=dm.NumberFromHexadecimal(textHash.getText().toLowerCase().substring(1));
					}
					else
						hash=Long.valueOf(textHash.getText()).longValue();
				}
				else
					textHash.setText("h"+Long.toHexString(hash).toUpperCase());
		
				Crc32Provider crc = new Crc32Provider();
				ArrayList base = new ArrayList();
				String chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789 ";
				int depth = 0;
		
				while(true){
					textAreaResult.setText(textAreaResult.getText()+ "Depth " + (depth + 4) + "\n");			
					base.clear();
					
					for(int i=0; i<depth; i++)
						base.add(Integer.valueOf(0));
					
					while(true){
						String baseString = "";
						
						if(stopSwingWorker){
							this.interrupt();
							return null;
						}
						
						for(int i=0; i<depth; i++)
							baseString+=chars.charAt(Integer.valueOf(base.get(i).toString()).intValue());
						
						crc.reset();
						crc.update(baseString);
						String patch = crc.patch(hash);
						
						int clean = 1;
						
						for(int i=0; i<patch.length(); i++){
							if(chars.indexOf(patch.charAt(i))==-1)
								clean=0;
						}					
						
						if (clean==1) {
							textAreaResult.setText(textAreaResult.getText() + baseString+patch + "\n");
							if ("".equals(textFileContent)) {
								textFileContent = baseString+patch;
								itemFileSave.setEnabled(true);
							}
						}
						
						int i=0;
						
						while (i < depth && Integer.valueOf(base.get(i).toString()).intValue()==chars.length()-1){
							base.set(i, Integer.valueOf(0));
							i++;
						}
						
						if(i==depth)
							break;
						
						base.set(i, Integer.valueOf(Integer.valueOf(base.get(i).toString()).intValue()+1));
					}
					
					depth++;
				}
			}
		};
	}

	private void buttonEndActionPerformed(ActionEvent evt) {
		//System.out.println("buttonEnd.actionPerformed, event="+evt);
		stopSwingWorker = true;
	}

	private void buttonCleanActionPerformed(ActionEvent evt) {
		//System.out.println("buttonClean.actionPerformed, event="+evt);
		textAreaResult.setText("");
		textHash.setText("");
		textFileContent = "";
		itemFileSave.setEnabled(false);
	}

	private void ChangeLanguage(int NLanguage){
		switch(NLanguage){
		case 1:
			itemFileGetHash.setText("Get hash from file");
			itemFileSave.setText("Save file with given hash");
			itemFileExit.setText("Exit");
			menuLanguage.setText("Language");
			itemLanguageEnglish.setText("English");
			itemLanguageItaliano.setText("Italian");
			menuHelp.setText("Help");
			getDialogAbout().setTitle("About");
			itemHelpAbout.setText("About");
			textAreaDialogAbout.setText("CRC Reverser v0.01\n (c) 2005 - Bas Westerbaan <bas.westerbaan@gmail.com>\n  Intrepid Software\n  Translated from Python to Java by Andrea Pannitti <andrea.pannitti@gmail.com>\n  GUI by Andrea Pannitti using Jigloo");
			Label1.setText("CRC32 hash (decimal or h<exadecimal>):");
			buttonStart.setText("Start");
			buttonEnd.setText("End");
			buttonClean.setText("Clean");
			break;
		
		case 2:
			itemFileGetHash.setText("Preleva hash da file");
			itemFileSave.setText("Salva file con hash dato");
			itemFileExit.setText("Esci");
			menuLanguage.setText("Lingua");
			itemLanguageEnglish.setText("Inglese");
			itemLanguageItaliano.setText("Italiano");
			menuHelp.setText("Aiuto");
			getDialogAbout().setTitle("Informazioni");
			itemHelpAbout.setText("Informazioni");
			textAreaDialogAbout.setText("CRC Reverser v0.01\n (c) 2005 - Bas Westerbaan <bas.westerbaan@gmail.com>\n  Intrepid Software\n  Tradotto da Python a Java da Andrea Pannitti <andrea.pannitti@gmail.com>\n  GUI di Andrea Pannitti usando Jigloo");
			Label1.setText("CRC32 hash (decimale o h<esadecimale>):");
			buttonStart.setText("Inizio");
			buttonEnd.setText("Fine");
			buttonClean.setText("Pulisci");
			break;

		default:
			ChangeLanguage(1);
			break;
		}
	}
}
