import java.util.ArrayList;

public class CrcReverser {
	public static void main(String[] args) {
		Datamanipulation dm = new Datamanipulation();
		//System.out.println(dm.NumberFromHexadecimal("ffffffff"));
		//System.out.println(dm.NumberToHexadecimal(4294967295L));
		//System.out.println(dm.NumberToBinary(4294967295L));
		//System.out.println(dm.NumberFromBinary("11111111111111111111111111111111"));
		//System.out.println("ASC: "+Integer.valueOf("A".toCharArray()[0]));
		//System.out.println("CHR: "+String.valueOf((char)65));
		/*Crc32Provider crc = new Crc32Provider();
		ArrayList tab = crc.generateTable();
		System.out.println(tab);
		crc.showTable();*/
		//long hash = 3711407533L;
		long hash = 4157704578L;
		if(args.length > 0){
			if(args[0].toLowerCase().charAt(0)=='h'){
				hash=dm.NumberFromHexadecimal(args[0].toLowerCase().substring(1));
			}
			else
				hash=Long.valueOf(args[0]).longValue();
		}
		Crc32Provider crc = new Crc32Provider();
		ArrayList base = new ArrayList();
		String chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789 ";
		int depth = 0;
		
		System.out.println("CRC Reverser v0.01");
		System.out.println(" (c) 2005 - Bas Westerbaan <bas.westerbaan@gmail.com>");
		System.out.println("  Intrepid Software");
		System.out.println("  Translated from Python to Java by Andrea Pannitti <andrea.pannitti@gmail.com>");
		//System.out.println("\nReversing the hash " + dm.PadStringLeft(dm.NumberToHexadecimal(hash), crc.width, '0'));
		System.out.println("\nReversing the hash " + dm.PadStringLeft(Long.toHexString(hash), crc.width, '0'));
		while(true){
			System.out.println("Depth " + (depth + 4));			
			base.clear();
			
			for(int i=0; i<depth; i++)
				base.add(Integer.valueOf(0));
			
			while(true){
				String baseString = "";
				
				for(int i=0; i<depth; i++)
					baseString+=chars.charAt(Integer.valueOf(base.get(i).toString()).intValue());
				
				crc.reset();
				crc.update(baseString);
				String patch = crc.patch(hash);
				
				int clean = 1;
				
				for(int i=0; i<patch.length(); i++){
					if(chars.indexOf(patch.charAt(i))==-1)
						clean=0;
				}					
				
				if (clean==1)
					System.out.println(baseString+patch);
				
				int i=0;
				
				while (i < depth && Integer.valueOf(base.get(i).toString()).intValue()==chars.length()-1){
					base.set(i, Integer.valueOf(0));
					i++;
				}
				
				if(i==depth)
					break;
				
				base.set(i, Integer.valueOf(Integer.valueOf(base.get(i).toString()).intValue()+1));
			}
			
			depth++;
		}
	}
}
